stages:
  # build_application
  - build_docker_image
  - deploy_to_ecs

variables:
  # CI variables: AWS_CLUSTER_NAME, AWS_SERVICE_NAME, AWS_FAMILY_NAME, APP_NAME
  npm_config_cache: "$CI_PROJECT_DIR/.npm"

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - .npm
    - node_modules

#build_application:
 # image: node:10
 # stage: build_application
 # script:
 #   - echo "//registry.npmjs.org/:_authToken=$NPM_TOKEN" > ~/.npmrc
 #   - npm install
 #   - npm test

publishing:
  stage: build_docker_image 
  image: docker:latest
  services:
    - docker:dind
  only: 
    - master
  script:
    - export DEBIAN_FRONTEND=noninteractive

    # Install nodejs and python
    - apk update && apk add -y --no-cache nodejs curl unzip bash
    - apk add --no-cache python3 && python3 -m ensurepip && rm -r /usr/lib/python*/ensurepip && pip3 install --upgrade pip setuptools && if [ ! -e /usr/bin/pip ]; then ln -s pip3 /usr/bin/pip ; fi && if [[ ! -e /usr/bin/python ]]; then ln -sf /usr/bin/python3 /usr/bin/python; fi && rm -r /root/.cache

    # Install AWS CLI
    - curl "https://s3.amazonaws.com/aws-cli/awscli-bundle.zip" -o "awscli-bundle.zip"
    - unzip awscli-bundle.zip
    - ./awscli-bundle/install -i /usr/local/aws -b /usr/local/bin/aws

    # Login to AWS ECR
    - $(aws ecr get-login --no-include-email --region eu-west-2)

    # Build all images over here. This is only a placeholder for
    - export dockerfile='./.docker/Dockerfile'
    - export DOCKER_IMAGE_NAME=$AWS_SERVICE_NAME:$CI_PIPELINE_ID-$CI_COMMIT_SHORT_SHA
    - export DOCKER_IMAGE_FULL=916768316819.dkr.ecr.eu-west-2.amazonaws.com/$DOCKER_IMAGE_NAME
    - echo $DOCKER_IMAGE_FULL
    - docker build --build-arg NPM_TOKEN=${NPM_TOKEN} --file ${dockerfile} -t $DOCKER_IMAGE_FULL .
    - docker push $DOCKER_IMAGE_FULL

deploying:
  image: docker:latest
  stage: deploy_to_ecs
  when: manual
  services:
    - docker:dind
  only: 
    - master
  script:
    - export DEBIAN_FRONTEND=noninteractive

    # Install nodejs and python
    - apk update && apk add --no-cache nodejs curl unzip bash gettext libintl jq
    - curl -L https://github.com/a8m/envsubst/releases/download/v1.1.0/envsubst-`uname -s`-`uname -m` -o envsubst
    - chmod +x envsubst
    - mv envsubst /usr/local/bin
    - apk add --no-cache python3 && python3 -m ensurepip && rm -r /usr/lib/python*/ensurepip && pip3 install --upgrade pip setuptools && if [ ! -e /usr/bin/pip ]; then ln -s pip3 /usr/bin/pip ; fi && if [[ ! -e /usr/bin/python ]]; then ln -sf /usr/bin/python3 /usr/bin/python; fi && rm -r /root/.cache

    # Install AWS CLI
    - curl "https://s3.amazonaws.com/aws-cli/awscli-bundle.zip" -o "awscli-bundle.zip"
    - unzip awscli-bundle.zip
    - ./awscli-bundle/install -i /usr/local/aws -b /usr/local/bin/aws

    # Login to AWS ECR
    - $(aws ecr get-login --no-include-email --region eu-west-2)

    # Local variables
    - /bin/bash -c "envsubst < .docker/task.template.json > .docker/api.template.json"
    #- export TASK_VERSION=$(aws ecs register-task-definition --cli-input-json file://.docker/api.template.json --family ${AWS_FAMILY_NAME} --region eu-west-2 | jq --raw-output '.taskDefinition.revision')
    #- export TASK_DEFINITION=${APP_NAME}-master:${TASK_VERSION}
    #- echo $TASK_DEFINITION
    # aws ecs update-service --cluster $AWS_CLUSTER_NAME --service $AWS_SERVICE_NAME --task-definition ${TASK_DEFINITION} --region eu-west-2
    - export TASK_DEFINITION=${AWS_SERVICE_NAME}:1
    - aws ecs update-service --cluster $AWS_CLUSTER_NAME --service $AWS_SERVICE_NAME --task-definition ${TASK_DEFINITION} --region eu-west-2